/* GCC */
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <cmath>
#include <stdio.h>

using namespace std;

#define fast ios_base::sync_with_stdio(false);cin.tie(false);cout.tie(false)
#define endl '\n'
#define file(s) freopen(s ".in", "r", stdin); freopen(s ".out", "w", stdout);

typedef long long ll;

const ll mod = 1e9;
const ll base = 47;
const ll total = 100003;

vector <ll> p_pow;
vector <ll> d;
vector <ll> hashh;
vector <ll> back_hashh;
int n;

bool check(int l, int r){
    ll h1 = (hashh[r] - hashh[l - 1] + mod) % mod,
       h2 = (back_hashh[n - l] - back_hashh[n - r - 1] + mod) % mod;
    h1 = (h1 * p_pow[total - l]) % mod;
    h2 = (h2 * p_pow[total - n + r]) % mod;
    return h1 == h2;
}

int main(){
    file("symmetry");
    p_pow.resize(total);
    p_pow[0] = 1;
    for (ll i = 1; i < total; i++)
        p_pow[i] = (p_pow[i-1] * base) % mod;
    int t;
    scanf("%d", &t);
    while (t--){
        int pre;
        scanf("%d%d", &n, &pre);
        for (int i = 1; i < n; i++){
            int x;
            scanf("%d", &x);
            d.push_back(x - pre);
            pre = x;
        }
        hashh.assign(n,0);
        back_hashh.assign(n,0);
        for (int i = 0; i < n - 1; i++){
            hashh[i + 1] = (hashh[i] + p_pow[i] * d[i]) % mod;
            back_hashh[i + 1] = (back_hashh[i] + p_pow[i] * d[d.size() - 1 - i]) % mod;
        }
        bool f = true;
        for (int i = 0; i + 1 < n && f; i++)
            if (check(1,i) && check(i + 2, n - 1)){
            printf("%d\n", i + 1);
            f = false;
        }
        if (f) printf("0\n");
        if (t)
        {
            d.clear();
            hashh.clear();
            back_hashh.clear();
        }
    }
}
