/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
typedef long long int64;
int n, m, s;
int64 k;
vector<vector<int> > in;
vector<int> sufMeans, prefMeans;
vector< pair<int, int> > suf, pref;

void readData(){
    freopen("aliens.in", "r", stdin);

    cin>>n>>m>>k;
    in.assign(m, vector<int>(n));
    for(int i=0; i<m; i++){
        for(int z=0; z<n; z++){
            scanf("%d", &in[i][z]);
        }
    }

    fclose(stdin);
}

void generateArr(vector< pair<int, int> > &arr, int pos, int maxPos, int sum, int mask){
    if(pos==maxPos){
        arr.push_back(make_pair(sum, mask));
        return;
    }

    mask*=n;
    for(int i=0; i<n; i++){
        generateArr(arr, pos+1, maxPos, sum+in[pos][i], mask+i);
    }
}

int64 getLess(vector<pair<int, int> > &arr, int a){
    return lower_bound(arr.begin(), arr.end(), make_pair(a, 0))-arr.begin();
}
int64 getGreater(vector<pair<int, int> > &arr, int a){
    return arr.size()-getLess(arr, a+1);
}
int64 getEqual(vector<pair<int, int> > &arr, int a){
    return getLess(arr, a+1)-getLess(arr, a);
}
int64 f(int a){
    int64 counter=0;
    for(int i=0; i<pref.size(); i++){
        counter+=getGreater(suf, a-pref[i].first);
    }
    return counter;
}

pair<int, int> getAnswer(){
    s=m/2;
    if(m%2==1) s++;

    pref.reserve(pow(n, s));
    suf.reserve(pow(n, m-s));
    generateArr(pref, 0, s, 0, 0);
    generateArr(suf, s, m, 0, 0);
    sort(suf.begin(), suf.end());
    sort(pref.begin(), pref.end());

    sufMeans=vector<int>(suf.size());
    prefMeans=vector<int>(pref.size());
    for(int i=0; i<suf.size(); i++){
        sufMeans[ suf[i].second ]=suf[i].first;
    }
    for(int i=0; i<pref.size(); i++){
        prefMeans[ pref[i].second ]=pref[i].first;
    }

    int minMean=suf[0].first+pref[0].first;
    int maxMean=suf.back().first+pref.back().first;
    int i=minMean, z=maxMean, j;
    while(z-i>1){
        j=i+(z-i)/2;
        if( f(j)<k ) z=j;
        else i=j;
    }
    int mean=z;
    k-=f(mean);

    int l, r, rightNeeded, amount;
    for(l=0; l<pref.size(); l++){
        rightNeeded=mean-pref[l].first;
        amount=getEqual(suf, rightNeeded);
        if(amount>=k){      //prefix found
            for(r=0; r<suf.size(); r++){
                if(rightNeeded==suf[r].first){
                    k--;
                    if(k==0) return make_pair(pref[l].second, suf[r].second);
                }
            }
        }
        k-=amount;
    }
}

string getStr(int a, int dig){
    string str;
    for(int i=0; i<dig; i++){
        str+='a'+(a%n);
        a/=n;
    }
    reverse(str.begin(), str.end());
    return str;
}

void fileOut(pair<int, int> a){
    freopen("aliens.out", "w", stdout);

    cout<<getStr(a.first, s)<<getStr(a.second, m-s)<<endl;

    fclose(stdout);
}

int main(){
    readData();
    fileOut(getAnswer());
    return 0;
}
