/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
int n;
const int m=40000;
vector<int> line, ans, aPows;

bool check(int a, int b){
    for(int i=0; i<=(b-a)/2; i++){
        if(line[a+i]!=line[b-i]) return false;
    }
    return true;
}

int solve(){
    int a=3;
    aPows=vector<int>(n);
    aPows[0]=1;
    for(int i=1; i<n; i++){
        aPows[i]=(aPows[i-1]*a)%m;
    }

    vector<int> gl(n), gr(n), hl(n), hr(n);

    gl[0]=line[0];
    hl[0]=line[0];
    for(int i=1; i<n; i++){
        hl[i]=(hl[i-1]*a+line[i])%m;
        gl[i]=(gl[i-1]+line[i]*aPows[i])%m;
    }

    gr[n-1]=line[n-1];
    hr[n-1]=line[n-1];
    for(int i=n-2; i>=0; i--){
        hr[i]=(hr[i+1]*a+line[i])%m;
        gr[i]=(gr[i+1]+line[i]*aPows[n-1-i])%m;
    }


    if(gr[1]==hr[1] && check(1, n-1)) return 1;
    for(int i=0; i<n-2; i++){
        if(hl[i]==gl[i] && hr[i+2]==gr[i+2] && check(0, i) && check(i+2, n-1)) return i+2;
    }
    if(gl[n-2]==hl[n-2] && check(0, n-2)) return n;
    return 0;
}

void readData(){
    freopen("symmetry.in", "r", stdin);

    int tests, p, c;
    scanf("%d", &tests);
    for(int i=0; i<tests; i++){
        scanf("%d%d", &n, &p);
        n--;
        line=vector<int>(n);
        for(int z=0; z<n; z++){
            scanf("%d", &c);
            line[z]=c-p;
            p=c;
        }
        ans.push_back(solve());
    }

    fclose(stdin);
}

void fileOut(){
    freopen("symmetry.out", "w", stdout);

    for(int i=0; i<ans.size(); i++){
        printf("%d\n", ans[i]);
    }

    fclose(stdout);
}

int main(){
    readData();
    fileOut();
    return 0;
}
