#include<iostream>
#include<vector>
#include<algorithm>
#include<cstdio>

using namespace std;

long long n, m, k, s;
int arr[10][16];

vector<int> suf_sums;
void suf_init(int sum, int index){
    if(index == s){
        suf_sums.push_back(sum);
        return;
    }
    for(int i = 0; i < n; ++i)
        suf_init(sum + arr[index + m - s][i], index+1);
}

vector<int> pref_sums;
void pref_init(int sum, int index){
    if(index == m-s){
        pref_sums.push_back(sum);
        return;
    }
    for(int i = 0; i < n; ++i)
        pref_init(sum + arr[index][i], index+1);
}

void init(){
    if(m == 10)
        s = 6;
    else
        s = (m+1)/2;
    suf_init(0, 0);
    sort(suf_sums.begin(), suf_sums.end());
    pref_init(0, 0);
    sort(pref_sums.begin(), pref_sums.end());
}

long long h(int num){
    return lower_bound(suf_sums.begin(), suf_sums.end(), num) - suf_sums.begin();
}

long long g(int num, int index){
    if(num + 1 < 0)
        return 0;
    if(index == m)
        return num == 0;
    if(index == m - s)
        return h(num + 1) - h(num);
    long long count_nums = 0;
    for(int i = 0; i < n; ++i)
        count_nums += g(num - arr[index][i], index + 1);
    return count_nums;
}

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    freopen("aliens.in", "r", stdin);
    freopen("aliens.out", "w", stdout);
    cin >> n >> m >> k;
    for(int i = 0; i < m; ++i)
    for(int j = 0; j < n; ++j)
        cin >> arr[i][j];
    init();
    long long l = suf_sums[0] + pref_sums[0] - 1,
              r = suf_sums.back() + pref_sums.back();
    while(l+1 < r){
        long long m = (l+r)/2;
        long long f_m = 0;
        for(int i = 0; i < pref_sums.size(); ++i)
            f_m += suf_sums.size() - h(m - pref_sums[i] + 1);
        if(f_m < k)
            r = m;
        else
            l = m;
    }
    long long f_r = 0;
    for(int i = 0; i < pref_sums.size(); ++i)
        f_r += suf_sums.size() - h(r - pref_sums[i] + 1);
    long long num = k - f_r,
              sum = r;
    string ans = "";
    for(int i = 0; i < m; ++i){
        for(int j = 0; j < n; ++j){
            long long g_s = g(sum - arr[i][j], i+1);
            if(num > g_s)
                num -= g_s;
            else{
                sum -= arr[i][j];
                ans += 'a' + j;
                break;
            }
        }
    }
    cout << ans << endl;
}
