/* GCC */
#include <iostream>
#include <cstdio>

using namespace std;

const long long mod = 1000*1000*1000+7,
                    p = 1117;

long long n,temp,T,last,Hash[100010],BackHash[100010],d[100010],Power[100010];

void FillHash(){
    Hash[0] = d[0];
    for (long i = 1;i < n-1;i++){
        Hash[i] = (Hash[i-1] + d[i]*Power[i]) % mod;
    }
}

void FillBackHash(){
    BackHash[n-2] = d[n-2];
    for (long i = n-3;i >= 0;i--){
        BackHash[i] = (BackHash[i+1] + d[i]*Power[n-2-i]) % mod;
    }
}

long long GetHash(long Ind1,long Ind2,long Pow){
    if (Ind1 == 0) return (Hash[Ind2]*Power[Pow]) % mod;
    return ((Hash[Ind2] - Hash[Ind1-1] + mod)*Power[Pow]) % mod;
}

long long GetBackHash(long Ind1,long Ind2,long Pow){
    if (Ind2 == n-2) return (BackHash[Ind1]*Power[Pow]) % mod;
    return ((BackHash[Ind1] - BackHash[Ind2+1] + mod)*Power[Pow]) % mod;
}

bool isPal(long Ind1,long Ind2){
    if (Ind1>=Ind2) return 1;
    long l = Ind1,
            r = n-2 - Ind2;
    return GetHash(Ind1,Ind2,max(l-l,r-l))==GetBackHash(Ind1,Ind2,max(r-r,l-r));
}

bool isBorder(long Index){
    return (isPal(0,Index-1)&&isPal(Index+1,n-2));
}

int main()
{
    freopen("symmetry.in","r",stdin);
    freopen("symmetry.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    Power[0] = 1;
    for (long i = 1;i < 100005;i++){
        Power[i] = (Power[i-1]*p) % mod;
    }
    cin >> T;
    while(T--){
    cin >> n;
    cin >> last;
    for (long i = 1;i < n;i++){
        cin >> temp;
        d[i-1] = temp - last;
        last = temp;
    }
    FillHash();
    FillBackHash();
    bool ready = 0;
    for (long i = 0;i < n-1;i++)
        if (isBorder(i)){
        cout << i + 1 << '\n';
        ready = 1;
        break;
    }
    if (!ready) cout << 0 << '\n';
    }

    return 0;
}
